## lomiri-dekko-app 0.4.1+dfsg

=== requirements.txt ===
markdown==3.3.3
markupsafe==1.1.1
cssutils==2.1.0
jinja2
pynliner
pygments
html2text
importlib-metadata==1.7.0
zipp
soupsieve

=== click/CMakeLists.txt ===
file(GLOB_RECURSE CLICK_FILES
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} * *.*
)
add_custom_target(ClickSrcs ALL SOURCES ${CLICK_FILES})

if (UNCONFINED)
    set(APPARMOR_MANIFEST ${CMAKE_CURRENT_SOURCE_DIR}/openstore/dekko.apparmor)
else()
    set(APPARMOR_MANIFEST ${CMAKE_CURRENT_SOURCE_DIR}/dekko.apparmor)
endif()

set(CLICK_MANIFEST ${CMAKE_CURRENT_SOURCE_DIR}/dekko.json)

set(OTHER_MANIFEST
    ${CMAKE_CURRENT_SOURCE_DIR}/.excludes
    ${APPARMOR_MANIFEST}
    ${CMAKE_CURRENT_SOURCE_DIR}/dekko.dekkoproject_dekko.application
    ${CMAKE_CURRENT_SOURCE_DIR}/dekko.dekkoproject_dekko.service
    ${CMAKE_CURRENT_SOURCE_DIR}/dekko.url-dispatcher
    ${CMAKE_CURRENT_SOURCE_DIR}/dekko-content.json
    ${CMAKE_CURRENT_SOURCE_DIR}/dekkohelper-aa.json
    ${CMAKE_CURRENT_SOURCE_DIR}/dekko-helper.json
)

if (CLICK_MODE)
    configure_file(${CLICK_MANIFEST} ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/manifest.json
        ${OTHER_MANIFEST}
        DESTINATION ${CMAKE_INSTALL_PREFIX}
    )
    install(
        PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/dekko-launch
        DESTINATION ${BIN_DIR}
    )
    install(
        PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/dekko-helper
        DESTINATION ${CMAKE_INSTALL_PREFIX}
    )
endif()

=== plugins/controls/CMakeLists.txt ===
project(dekko-controls)
cmake_minimum_required(VERSION 3.0)
set(CMAKE_GENERATOR "Unix Makefiles")

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_AUTOMOC True)

if (CMAKE_BUILD_TYPE MATCHES Debug)
    set(CMAKE_CXX_FLAGS "-O0 -g -Wall -Wsign-compare ${CMAKE_CXX_FLAGS}")
else()
    set(CMAKE_CXX_FLAGS "-O2 -Wall -Wsign-compare ${CMAKE_CXX_FLAGS} -s")
endif()

message(STATUS "CXXFLAGS ARE ${CMAKE_CXX_FLAGS}")

include(GNUInstallDirs)

if(DEFINED QT_IMPORTS_DIR)
    message(STATUS "Qt import dir already set, install MazDB Quick Plugin to ${QT_IMPORTS_DIR}")
else()
    if(EXISTS "/etc/debian_version")
        set(QT_IMPORTS_DIR ${CMAKE_INSTALL_LIBDIR}/qt5/qml)
    else()
        set(QT_IMPORTS_DIR ${CMAKE_INSTALL_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}/qt5/qml)
    endif()
endif()

find_package(Qt5Core 5.4 REQUIRED)
find_package(Qt5Quick 5.4 REQUIRED)
find_package(Qt5Svg 5.4 REQUIRED)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/src
)

set(ControlsPlugin_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/src/ControlsPlugin.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/src/QQuickStack.cpp
)

add_library(controlsplugin MODULE ${ControlsPlugin_SRCS})

qt5_use_modules(controlsplugin Core Quick Svg)

set(CONTROLS_PLUGIN_DIR ${QT_IMPORTS_DIR}/Dekko/Controls)

set(QML_CTRL_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/src/StackView.qml
    ${CMAKE_CURRENT_SOURCE_DIR}/src/StackViewTransition.qml
    ${CMAKE_CURRENT_SOURCE_DIR}/src/StackViewDelegate.qml
    ${CMAKE_CURRENT_SOURCE_DIR}/src/StackSlideDelegate.qml
    ${CMAKE_CURRENT_SOURCE_DIR}/src/Stack.js
    ${CMAKE_CURRENT_SOURCE_DIR}/src/qmldir
)
add_custom_target(DekkoControlsQml ALL SOURCES ${QML_CTRL_SRCS})


install(TARGETS controlsplugin DESTINATION ${CONTROLS_PLUGIN_DIR})
install(FILES ${QML_CTRL_SRCS} DESTINATION ${CONTROLS_PLUGIN_DIR})

=== plugins/plugman/CMakeLists.txt ===
project(plugger)
cmake_minimum_required(VERSION 3.0)
set(CMAKE_GENERATOR "Unix Makefiles")

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_AUTOMOC True)

if (CMAKE_BUILD_TYPE MATCHES Debug)
    set(CMAKE_CXX_FLAGS "-O0 -g -Wall -Wsign-compare ${CMAKE_CXX_FLAGS}")
else()
    set(CMAKE_CXX_FLAGS "-O2 -Wall -Wsign-compare ${CMAKE_CXX_FLAGS} -s")
endif()

message(STATUS "CXXFLAGS ARE ${CMAKE_CXX_FLAGS}")

include(GNUInstallDirs)

option(BUILD_EXAMPLE "Build the eample app" OFF)
mark_as_advanced(BUILD_EXAMPLE)

if(DEFINED LIB_DIR)
    message(STATUS "LIB_DIR already set. MazDB library will be installed to ${LIB_DIR}")
else()
    if(EXISTS "/etc/debian_version")
        set(LIB_DIR ${CMAKE_INSTALL_LIBDIR}/Dekko)
    else()
        set(LIB_DIR ${CMAKE_INSTALL_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}/Dekko)
    endif()

endif()

# Now setup qml plugin install paths
if(DEFINED QT_IMPORTS_DIR)
    message(STATUS "Qt import dir already set, install MazDB Quick Plugin to ${QT_IMPORTS_DIR}")
else()
    if(EXISTS "/etc/debian_version")
        set(QT_IMPORTS_DIR ${CMAKE_INSTALL_LIBDIR}/qt5/qml)
    else()
        set(QT_IMPORTS_DIR ${CMAKE_INSTALL_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}/qt5/qml)
    endif()
endif()

add_subdirectory(src)
if(BUILD_EXAMPLE)
    add_subdirectory(example)
endif()

=== plugins/controls/src/CMakeLists.txt ===
find_package(Qt5Core 5.4 REQUIRED)
find_package(Qt5Quick 5.4 REQUIRED)
find_package(Qt5Svg 5.4 REQUIRED)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
)

set(ControlsPlugin_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/ControlsPlugin.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/QQuickStack.cpp
)

add_library(controlsplugin MODULE ${ControlsPlugin_SRCS})

qt5_use_modules(controlsplugin Core Quick Svg)

set(CONTROLS_PLUGIN_DIR ${QT_IMPORTS_DIR}/Dekko/Controls)

set(QML_CTRL_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/StackView.qml
    ${CMAKE_CURRENT_SOURCE_DIR}/StackViewTransition.qml
    ${CMAKE_CURRENT_SOURCE_DIR}/StackViewDelegate.qml
    ${CMAKE_CURRENT_SOURCE_DIR}/StackSlideDelegate.qml
    ${CMAKE_CURRENT_SOURCE_DIR}/Stack.js
    ${CMAKE_CURRENT_SOURCE_DIR}/qmldir
)
add_custom_target(DekkoControlsQml ALL SOURCES ${QML_CTRL_SRCS})


install(TARGETS controlsplugin DESTINATION ${CONTROLS_PLUGIN_DIR})
install(FILES ${QML_CTRL_SRCS} DESTINATION ${CONTROLS_PLUGIN_DIR})

=== plugins/plugman/example/CMakeLists.txt ===
find_package(Qt5Core 5.4 REQUIRED)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${SHARED_SRCS}
    ${CMAKE_SOURCE_DIR}/src
)

set(example_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
)


add_executable(example ${example_SRCS})
qt5_use_modules(example Core Quick)
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/plugins DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/Main.qml DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(example dekko-plugins)


set(service_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/NotifySendService.cpp
)

add_library(notify-service SHARED ${service_SRCS})
qt5_use_modules(notify-service Core)
target_link_libraries(notify-service dekko-plugins)
set_target_properties(notify-service PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/plugins)

=== plugins/plugman/src/CMakeLists.txt ===
find_package(Qt5Core 5.4 REQUIRED)
find_package(Qt5Quick 5.4 REQUIRED)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${SHARED_SRCS}
)

set(libPlugin_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/PluginRegistry.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PluginInfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PluginLoader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ActionRegistry.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ServiceRegistry.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ItemRegistry.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ListenerRegistry.cpp
)


add_library(dekko-plugins SHARED ${libPlugin_SRCS})
qt5_use_modules(dekko-plugins Core Quick)

install(TARGETS dekko-plugins DESTINATION ${LIB_DIR})

set(PLUGIN_LIB_INC ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(quick)

=== plugins/plugman/src/quick/CMakeLists.txt ===
include_directories(
    ${PLUGIN_LIB_INC}
)

set(pluggerQuick_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/QuickPlugger.cpp
)

add_library(quick-plugger MODULE ${pluggerQuick_SRCS})
qt5_use_modules(quick-plugger Core Quick)
target_link_libraries(quick-plugger dekko-plugins)


set(PLUGGER_DIR ${QT_IMPORTS_DIR}/Plugger)

install(TARGETS quick-plugger DESTINATION ${PLUGGER_DIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/qmldir DESTINATION ${PLUGGER_DIR})

=== debian/changelog ===
lomiri-dekko-app (0.4.1+dfsg-8) unstable; urgency=medium

  * debian/patches:
    + Add 2007_hide-app-if-not-in-lomiri.patch.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 May 2025 17:07:07 +0200

lomiri-dekko-app (0.4.1+dfsg-7) unstable; urgency=medium

  [ Guido Berhoerster ]
  * debian/:
    + Install DBus service file for DBus activation.
    + Add qmf-have-account and use it in systemd service.

  [ Mike Gabriel ]
  * debian/control:
    + Add to D (lomiri-dekko-app): lomiri-app-launch-tools.
  * debian/bin/lomiri-dekko-app:
    + Launch dekko via lomiri-app-launch.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 02 May 2025 11:58:50 +0200

lomiri-dekko-app (0.4.1+dfsg-6) unstable; urgency=medium

  * debian/control:
    + Fix QML module name (qml-module-lomiri-content-hub -> qml-module-lomiri-
      content).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 05 Apr 2025 10:35:14 +0200

lomiri-dekko-app (0.4.1+dfsg-5) unstable; urgency=medium

  * debian/control:
    + Add D: (dekko): qml-module-lomiri-content-hub. (Closes: #1102100).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 05 Apr 2025 10:28:33 +0200

lomiri-dekko-app (0.4.1+dfsg-4) unstable; urgency=medium

  [ Guido Berhoerster ]
  * debian/*:
    + Update to qmf 5.0~git20250326.d27f464
  * debian/patches/:
    + Remove 2003-Add-workaround-for-race-condition-in-qmf-during-acco.patch.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 31 Mar 2025 15:21:20 +0200

lomiri-dekko-app (0.4.1+dfsg-3) unstable; urgency=medium

  * debian/control:
    + Add D: qml-module-qtqml-statemachine. (Closes: #1095253).
    + Sort D: field.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 08 Feb 2025 18:46:19 +0100

lomiri-dekko-app (0.4.1+dfsg-2) unstable; urgency=medium

  * debian/control:
    + Add D: (dekko): qml-module-lomiri-components, qml-module-qtquick-
      controls2-suru and qml-module-qtwebengine. (Closes: #1095208).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 05 Feb 2025 13:28:01 +0100

lomiri-dekko-app (0.4.1+dfsg-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1093875). Thanks to Guido Berhörster
    and Cosima Neidahl for helping with this huge project (upstream and
    downstream).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 27 Jan 2025 10:08:54 +0100

=== debian/watch ===
version=4
opts="searchmode=plain, dversionmangle=s/\+dfsg//, repacksuffix=+dfsg" \
https://gitlab.com/dekkan/dekko/tags?sort=updated_desc -/archive/v?\d[\d.]+/dekko-@ANY_VERSION@@ARCHIVE_EXT@

## lomiri-dekko-app 0.5.2%2Bdfsg

=== i18n/CMakeLists.txt ===
list(APPEND DEKKO_TRANSLATIONS_TS
    am.ts
    bn_BD.ts
    ca.ts
    cs.ts
    da.ts
    de.ts
    el.ts
    en_GB.ts
    en.ts
    eo.ts
    es.ts
    et.ts
    fi.ts
    fr.ts
    gl.ts
    gu.ts
    he.ts
    hu.ts
    id.ts
    it.ts
    ja.ts
    ko.ts
    lt.ts
    nb.ts
    nds.ts
    nl.ts
    or.ts
    pl.ts
    pt_BR.ts
    pt.ts
    ro.ts
    ru.ts
    sc.ts
    si.ts
    sk.ts
    sq_AL.ts
    sr.ts
    sv.ts
    ta.ts
    th.ts
    tr.ts
    tzm.ts
    uk.ts
    zh_CN.ts
    zh_Hant_HK.ts
    zh_TW.ts
)

qt5_add_translation(DEKKO_TRANSLATIONS_QM ${DEKKO_TRANSLATIONS_TS})

# To force these to be converted
add_custom_target (Dekko_translations ALL DEPENDS ${DEKKO_TRANSLATIONS_QM})

install(FILES
    ${DEKKO_TRANSLATIONS_QM}
    DESTINATION ${DEKKO_PLUGINS_DIR}/ui/i18n
)

=== plugins/controls/CMakeLists.txt ===
project(dekko-controls)

include(GNUInstallDirs)

if(DEFINED QT_IMPORTS_DIR)
    message(STATUS "Qt import dir already set, install MazDB Quick Plugin to ${QT_IMPORTS_DIR}")
else()
    if(EXISTS "/etc/debian_version")
        set(QT_IMPORTS_DIR ${CMAKE_INSTALL_LIBDIR}/qt5/qml)
    else()
        set(QT_IMPORTS_DIR ${CMAKE_INSTALL_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}/qt5/qml)
    endif()
endif()

add_subdirectory(src)

=== Dekko/utils/js/CMakeLists.txt ===
install(FILES
    qmldir
    QtCoreAPI.js
    DESTINATION ${QT_IMPORTS_DIR}/Dekko/Utils
)

=== plugins/cache-manager-plugin/plugin/CMakeLists.txt ===
project(Dekko-cache-manager-plugin)

set(PLUGIN_TARGET dekko-cachemgr-plugin)

list(APPEND PLUGIN_SRCS
    cachemanagerplugin.cpp
)

add_library(${PLUGIN_TARGET} MODULE ${PLUGIN_SRCS})

target_compile_definitions(${PLUGIN_TARGET}
    PRIVATE
    DEKKO_VERSION="${Dekko_VERSION}"
)

target_include_directories(${PLUGIN_TARGET}
    PRIVATE
    ${QmfClient_INCLUDE_DIRS}
)

target_link_libraries(${PLUGIN_TARGET}
    PUBLIC
    mail
    plugman
    snap-standard-paths
    ${QmfClient_LIBRARIES}
    Qt5::Core
    Qt5::DBus
)

install(TARGETS
    ${PLUGIN_TARGET}
    DESTINATION ${DEKKO_PLUGINS_DIR}
)

=== plugins/controls/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,3 @@
-find_package(Qt5Core 5.4 REQUIRED)
-find_package(Qt5Quick 5.4 REQUIRED)
-find_package(Qt5Svg 5.4 REQUIRED)
-
-include_directories(
-    ${CMAKE_CURRENT_SOURCE_DIR}
-)
-
 set(ControlsPlugin_SRCS
     ${CMAKE_CURRENT_SOURCE_DIR}/ControlsPlugin.cpp
     ${CMAKE_CURRENT_SOURCE_DIR}/QQuickStack.cpp
@@ -13,7 +5,17 @@
 
 add_library(controlsplugin MODULE ${ControlsPlugin_SRCS})
 
-qt5_use_modules(controlsplugin Core Quick Svg)
+target_include_directories(controlsplugin
+    PUBLIC
+    ${CMAKE_CURRENT_SOURCE_DIR}
+)
+
+target_link_libraries(controlsplugin
+    PUBLIC
+    Qt5::Core
+    Qt5::Quick
+    Qt5::Svg
+)
 
 set(CONTROLS_PLUGIN_DIR ${QT_IMPORTS_DIR}/Dekko/Controls)
 
@@ -27,6 +29,5 @@
 )
 add_custom_target(DekkoControlsQml ALL SOURCES ${QML_CTRL_SRCS})
 
-
 install(TARGETS controlsplugin DESTINATION ${CONTROLS_PLUGIN_DIR})
 install(FILES ${QML_CTRL_SRCS} DESTINATION ${CONTROLS_PLUGIN_DIR})

## lomiri-dekko-app 0.5.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(Dekko VERSION 0.5.2)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_AUTOMOC ON)

find_package(Qt5
    COMPONENTS
    Core
    DBus
    Gui
    LinguistTools
    Quick
    QuickControls2
    Svg
    WebEngine
    Widgets
    Xml
    REQUIRED
)

find_package(Python
    COMPONENTS
    Interpreter
    REQUIRED
)

find_package(PkgConfig)
find_package(QuickFlux)

if(PkgConfig_FOUND)
    pkg_check_modules(LOMIRI_CONNECTIVITY lomiri-connectivity-qt1)
    pkg_search_module(QmfClient QmfClient-qt5)
    pkg_search_module(QmfMessageServer QmfMessageServer-qt5)
endif()
set(Qmf_FOUND FALSE)
if(QmfClient_FOUND AND QmfMessageServer_FOUND)
    set(Qmf_FOUND TRUE)
endif()

option(CLICK_MODE "Build in a click-compatible manner" ON)

if(CLICK_MODE)
    set(CMAKE_INSTALL_LIBDIR "lib/${CMAKE_LIBRARY_ARCHITECTURE}")
    set(CMAKE_INSTALL_BINDIR "${CMAKE_INSTALL_LIBDIR}/bin")
endif()

include(GNUInstallDirs)

option(DEKKO_SERVER_AS_THREAD "Run the messaging server as a qthread instead of a seperate qprocess" OFF)
option(DEKKO_ENABLE_QMF_LOGGING "Enable qmf internal logging" ON)
option(DEKKO_UNCONFINED "Unused: Allow to run without worrying about platform confinement - useful for debugging or running on tradition DE's." OFF)
option(DEKKO_ENABLE_UOA "Unused, EXPERIMENTAL: enables online accounts integration" OFF)
option(DEKKO_ENABLE_IMAP "Unused: Enables IMAP service" ON)
option(DEKKO_ENABLE_POP "Unused: Enables POP3 service" ON)
option(DEKKO_ENABLE_UI "Enable Lomiri UI Toolkit user interface" ON)

option(DEKKO_SYSTEM_QMF "Whether a system-installed QMF should be used, otherwise a vendored version is built & installed" "${Qmf_FOUND}")
option(DEKKO_SYSTEM_QUICKFLUX "Whether a system-installed quickflux should be used, otherwise a vendored version is built & installed" "${QuickFlux_FOUND}")

set(DEKKO_PYTHON_DIR "" CACHE STRING "Path with python packages that should be included")

if(CLICK_MODE)
    set(QT_IMPORTS_DIR ${CMAKE_INSTALL_LIBDIR})
elseif(DEFINED QT_IMPORTS_DIR)
    message(STATUS "Qt imports dir already set. Installing QML plugins to ${QT_IMPORTS_DIR}")
elseif(EXISTS "/etc/debian_version")
    set(QT_IMPORTS_DIR ${CMAKE_INSTALL_LIBDIR}/qt5/qml)
else()
    get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
    execute_process(
        COMMAND ${QMAKE_EXECUTABLE} -query QT_INSTALL_QML
        OUTPUT_VARIABLE QT_IMPORTS_DIR OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    file(TO_CMAKE_PATH "${QT_IMPORTS_DIR}" QT_IMPORTS_DIR)
endif()

set(DEKKO_DATA_DIR ${CMAKE_INSTALL_FULL_DATADIR}/dekko)
if(CLICK_MODE)
    set(DEKKO_PLUGINS_DIR ${CMAKE_INSTALL_FULL_BINDIR}/plugins)
else()
    set(DEKKO_PLUGINS_DIR ${CMAKE_INSTALL_FULL_LIBDIR}/dekko/plugins)
endif(CLICK_MODE)

configure_file(config.hpp.in ${CMAKE_BINARY_DIR}/config.hpp @ONLY)

set(DEKKO_INSTALL_PRIVATE_LIBDIR ${CMAKE_INSTALL_LIBDIR})
if (NOT CLICK_MODE)
    set(DEKKO_INSTALL_PRIVATE_LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR}/dekko)
    set(CMAKE_INSTALL_RPATH ${DEKKO_INSTALL_PRIVATE_LIBDIR})
endif()

message(AUTHOR_WARNING "Should we keep --unresolved-symbols=report-all here? It's nice for finding linking mistakes")
add_link_options(-Wl,--unresolved-symbols=report-all)

add_subdirectory(snap-standard-paths EXCLUDE_FROM_ALL)

# All-headers
add_subdirectory(super-macros EXCLUDE_FROM_ALL)

# Help it find snap-standard-paths, don't need examples
set(SSP_LIBRARIES snap-standard-paths)
set(SSP_INCLUDE_DIRECTORY ${snap-standard-paths_SOURCE_DIR})
set(MAZDB_EXAMPLES OFF)
add_subdirectory(maz-db)

add_subdirectory(notify)

# Don't need example
set(RTE_EXAMPLE OFF)
add_subdirectory(richtext-editor)

add_subdirectory(upstream)

if(NOT DEKKO_SYSTEM_QMF)
    set(QmfMessageServer_LIBRARIES)
    set(QmfClient_LIBRARIES
        qmfclient5
        qmfmessageserver5
    )
    # QMF doesn't set these, so we must manually specify these
    set(QmfClient_INCLUDE_DIRS
        ${qmf_SOURCE_DIR}/libraries/qmfclient
        ${qmf_SOURCE_DIR}/libraries/qmfclient/support
    )
    set(QmfMessageServer_INCLUDE_DIRS
        ${qmf_SOURCE_DIR}/libraries/qmfmessageserver
    )
endif()

add_subdirectory(data)
add_subdirectory(i18n)
add_subdirectory(plugins)
add_subdirectory(Dekko)

=== Dekko/CMakeLists.txt ===
add_subdirectory(utils)
add_subdirectory(components)
add_subdirectory(backend)
add_subdirectory(server)

add_subdirectory(app)

add_subdirectory(api)
add_subdirectory(stores)
add_subdirectory(workers)

=== data/CMakeLists.txt ===
file(GLOB_RECURSE CLICK_FILES
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} * *.*
)
add_custom_target(ClickSrcs ALL SOURCES ${CLICK_FILES})

message(AUTHOR_WARNING "QBS build didn't use unconfined option, should the CMake one? Assuming unconfined, like qbs.")
if (TRUE)
    set(APPARMOR_MANIFEST openstore/dekko2.apparmor openstore/dekkod.apparmor)
else()
    set(APPARMOR_MANIFEST dekko.apparmor)
endif()

set(CLICK_MANIFEST manifest.json.in)

message(AUTHOR_WARNING "dekko.dekkoproject_dekko.* installation skipped, as QBS didn't seem to install them either")
set(OTHER_MANIFEST
    ${APPARMOR_MANIFEST}
    #dekko.dekkoproject_dekko.application
    #dekko.dekkoproject_dekko.service
    dekkod.desktop
    dekko2.url-dispatcher
    dekko2-content.json
    dekkohelper-aa.json
    dekko-helper.json
)

if (CLICK_MODE)
    set(APPEND_VERSION "" CACHE STRING "Appendix to dekko version")
    # Reduce the framework appendix to the OS version, e.g. 24.04-1.x
    string(REGEX MATCH "[0-9].*" VERSION_APPENDIX ${APPEND_VERSION})
    set(HOST_ARCH_TRIPLET ${CMAKE_LIBRARY_ARCHITECTURE})
    set(DESKTOP_EXEC "env DEKKO_PLUGINS=./lib/${HOST_ARCH_TRIPLET}/bin/plugins QMF_PLUGINS=./lib/${HOST_ARCH_TRIPLET}/qmf/plugins5 QMF_DATA_HOME=~/.cache/dekko2.dekkoproject dekko %U")
    set(DESKTOP_ICON dekko)
    set(VERSION "${PROJECT_VERSION}-${VERSION_APPENDIX}")
    execute_process(
        COMMAND dpkg-architecture -qDEB_HOST_ARCH
        OUTPUT_VARIABLE CLICK_ARCH
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )

    configure_file(${CLICK_MANIFEST} ${CMAKE_CURRENT_BINARY_DIR}/manifest.json @ONLY)
    configure_file(dekko2.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/dekko2.desktop @ONLY)

    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/manifest.json
        ${CMAKE_CURRENT_BINARY_DIR}/dekko2.desktop
        ${OTHER_MANIFEST}
        DESTINATION ${CMAKE_INSTALL_PREFIX}
    )
    install(PROGRAMS
        dekkod-launch
        DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
    install(PROGRAMS
        dekko-helper
        DESTINATION ${CMAKE_INSTALL_PREFIX}
    )
else()
    set(DESKTOP_EXEC "dekko %U")
    set(DESKTOP_ICON dekko)
    configure_file(dekko2.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/dekko2.desktop @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dekko2.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
endif()

=== maz-db/CMakeLists.txt ===
project(MazDB LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_EXTENSIONS FALSE)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

include(GNUInstallDirs)
include(CTest)

option(MAZDB_EXAMPLES "Build & install example(s)." ON)

find_package(Threads REQUIRED)

find_package(leveldb REQUIRED)

find_package(Qt5Core REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)

set(CMAKE_AUTOMOC ON)

find_library(SSP_LIBRARIES
    NAMES snap-standard-paths
    REQUIRED
)

find_path(SSP_INCLUDE_DIRECTORY
    NAMES SnapStandardPaths.h
    REQUIRED
)

if(BUILD_TESTING)
    find_package(Qt5QuickTest REQUIRED)
    find_package(Qt5Test REQUIRED)
endif()

if(DEFINED QT_IMPORTS_DIR)
    message(STATUS "QT_IMPORTS_DIR already set. Installing MazDB QML modules to ${QT_IMPORTS_DIR}")
else()
    get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
    execute_process(
        COMMAND ${QMAKE_EXECUTABLE} -query QT_INSTALL_QML
        OUTPUT_VARIABLE QT_IMPORTS_DIR OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    file(TO_CMAKE_PATH "${QT_IMPORTS_DIR}" QT_IMPORTS_DIR)
endif()

add_subdirectory(src)

if(MAZDB_EXAMPLES)
    add_subdirectory(example)
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== notify/CMakeLists.txt ===
project(dekko-notify)
set(CMAKE_GENERATOR "Unix Makefiles")

option(NOTIFY_TESTS "Enable notify tests" OFF)
mark_as_advanced(NOTIFY_TESTS)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_AUTOMOC True)

include(GNUInstallDirs)

set(NOTIFY_PATH ${CMAKE_CURRENT_SOURCE_DIR}/src)

set(notify_SRCS
    ${NOTIFY_PATH}/NotifyQueue.qml
    ${NOTIFY_PATH}/Notification.qml
    ${NOTIFY_PATH}/NotificationBase.qml
    ${NOTIFY_PATH}/Notify.qml
    ${NOTIFY_PATH}/NotifyConfiguration.qml
    ${NOTIFY_PATH}/qmldir
    ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE
)

add_custom_target(NotifySrcs ALL SOURCES ${notify_SRCS})

if(DEFINED QT_IMPORTS_DIR)
    message(STATUS "Qt imports dir already set. Installing Notify to ${QT_IMPORTS_DIR}")
else()
    find_package(Qt5Core REQUIRED)

    get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
    execute_process(
      COMMAND ${QMAKE_EXECUTABLE} -query QT_INSTALL_QML
      OUTPUT_VARIABLE QT_IMPORTS_DIR OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    file(TO_CMAKE_PATH "${QT_IMPORTS_DIR}" QT_IMPORTS_DIR)
endif()

install(
    FILES ${notify_SRCS}
    DESTINATION ${QT_IMPORTS_DIR}/Dekko/Notify
)

set(example_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/example/notify-example.qml
    ${CMAKE_CURRENT_SOURCE_DIR}/example/CustomNotification.qml
)

add_custom_target(ExampleSrcs ALL SOURCES ${example_SRCS})

add_custom_target("run" /usr/bin/qmlscene ${CMAKE_SOURCE_DIR}/example/notify-example.qml)

if(NOTIFY_TESTS)
    enable_testing()
endif()

=== plugins/CMakeLists.txt ===
project(Dekko-plugins)

add_subdirectory(plugman)
add_subdirectory(controls)

if(DEKKO_ENABLE_UI)
    add_subdirectory(ubuntu-plugin)
endif()

if(CLICK_MODE)
    add_subdirectory(ubuntu-notification-plugin)
endif()

add_subdirectory(cache-manager-plugin)

=== richtext-editor/CMakeLists.txt ===
project(qml-richtext-editor LANGUAGES NONE)

include(GNUInstallDirs)

option(RTE_EXAMPLE "Install example." ON)

if(DEFINED QT_IMPORTS_DIR)
    message(STATUS "Qt imports dir already set. Installing Notify to ${QT_IMPORTS_DIR}")
else()
    find_package(Qt5Core REQUIRED)

    get_target_property(QMAKE_EXECUTABLE Qt5::qmake LOCATION)
    execute_process(
      COMMAND ${QMAKE_EXECUTABLE} -query QT_INSTALL_QML
      OUTPUT_VARIABLE QT_IMPORTS_DIR OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    file(TO_CMAKE_PATH "${QT_IMPORTS_DIR}" QT_IMPORTS_DIR)
endif()

add_subdirectory(src)

if(RTE_EXAMPLE)
    add_subdirectory(example)
endif()

=== snap-standard-paths/CMakeLists.txt ===
project(snap-standard-paths LANGUAGES CXX)

include(GNUInstallDirs)

find_package(Qt5Core REQUIRED)

list(APPEND SSP_HEADERS
    SnapStandardPaths.h
)

list(APPEND SSP_SRCS
    SnapStandardPaths.cpp
)

add_library(snap-standard-paths STATIC ${SSP_SRCS})

target_include_directories(snap-standard-paths
    PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_link_libraries(snap-standard-paths
    PUBLIC
    Qt5::Core
)

=== super-macros/CMakeLists.txt ===
project(SuperMacros LANGUAGES NONE)

include(GNUInstallDirs)

list(APPEND SuperMacro_HDRS
    QQmlAutoPropertyHelpers.h
    QQmlConstRefPropertyHelpers.h
    QQmlEnumClassHelper.h
    QQmlHelpersCommon.h
    QQmlListPropertyHelper.h
    QQmlPtrPropertyHelpers.h
    QQmlVarPropertyHelpers.h
)

install(FILES ${SuperMacro_HDRS}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== upstream/CMakeLists.txt ===
set(ENABLE_LOGGING ${DEKKO_ENABLE_QMF_LOGGING})

if(NOT DEKKO_SYSTEM_QMF)
    add_subdirectory(qmf)
endif()

if(NOT DEKKO_SYSTEM_QUICKFLUX)
    add_subdirectory(quick-flux)
endif()

=== Dekko/api/CMakeLists.txt ===
add_subdirectory(public)

=== Dekko/app/CMakeLists.txt ===
project(Dekko-Mail)

list(APPEND dekko_SRCS
    Dekko.cpp
    main.cpp
)

qt5_add_resources(dekko_SRCS
    dekko.qrc
    assets/icons/actions/actionicons.qrc
    assets/icons/filetypes/filetypeicons.qrc
    assets/icons/providers/providericons.qrc
)

add_executable(dekko ${dekko_SRCS})

target_compile_definitions(dekko
    PRIVATE
    DEKKO_VERSION="${Dekko_VERSION}"
    DEKKO_PLUGINS_DIR="${DEKKO_PLUGINS_DIR}"
)

if(CLICK_MODE)
    target_compile_definitions(dekko
        PRIVATE
        CLICK_MODE
        APP_NAME="dekko2.dekkoproject"
        APP_ORG="dekko2.dekkoproject"
    )
else()
    target_compile_definitions(dekko
        PRIVATE
        SNAP_MODE
        APP_NAME="dekko"
        APP_ORG="dekkoproject"
    )
endif()

target_include_directories(dekko
    PRIVATE
    ${QmfClient_INCLUDE_DIRS}
    ${QmfMessageServer_INCLUDE_DIRS}
)

target_link_libraries(dekko
    PUBLIC
    network
    plugman
    snap-standard-paths
    ${QmfClient_LIBRARIES}
    ${QmfMessageServer_LIBRARIES}
    Qt5::Core
    Qt5::Gui
    Qt5::Qml
    Qt5::Quick
    Qt5::QuickControls2
    Qt5::Widgets
    Qt5::WebEngine
)

install(TARGETS
    dekko
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(DIRECTORY
    assets/configuration
    DESTINATION ${CMAKE_INSTALL_DATADIR}/dekko
)

if(CLICK_MODE)
    install(FILES
        assets/icons/dekko/dekko.png
        DESTINATION ${CMAKE_INSTALL_PREFIX}
    )
else()
    install(FILES
        assets/icons/dekko/dekko.png
        DESTINATION ${CMAKE_INSTALL_DATADIR}/pixmaps
    )
endif()

=== debian/changelog ===
lomiri-dekko-app (0.5.2+dfsg-1) unstable; urgency=medium

  [ Mike Gabriel ]
  * New upstream release.
  * debian/patches:
    + Trivial rebase of 2002-Build-against-Debian-qmf.patch for v0.5.2.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Add more files/dirs to global Excludes: field.
    + Update copyright attributions.
    + Update FSF mailing address.
  * debian/source/lintian-overrides:
    + Drop file. Not needed anymore.
  * debian/dekko.lintian-overrides:
    + Add one more custom-library-search-path override.

  [ Guido Berhörster ]
  * debian/*:
    + Update to dekko 0.5.x.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 28 Aug 2025 10:16:53 +0200

=== debian/control ===
Source: lomiri-dekko-app
Section: x11
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
 debhelper-compat (= 13),
 pkgconf,
 qtbase5-dev,
 qtdeclarative5-dev,
 qtquickcontrols2-5-dev,
 libqt5svg5-dev,
 qtwebengine5-dev,
 qttools5-dev,
 liblomiri-connectivity-qt1-dev,
# libsignon-qt5-dev,
# libaccounts-qt5-dev,
 libleveldb-dev,
 libsnappy-dev,
 python3,
 python3-setuptools,
 qml-module-quickflux,
 zlib1g-dev,
 libqmf-qt5-dev (>= 5.0~git20250326.d27f464),
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/dekkan/dekko/
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-dekko-app
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-dekko-app.git

Package: dekko
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 python3,
 python3-bs4,
 python3-cssutils,
 python3-html2text,
 python3-jinja2,
 python3-markdown,
 qml-module-io-thp-pyotherside,
 qml-module-lomiri-components,
 qml-module-lomiri-content,
 qml-module-qtqml-statemachine,
 qml-module-qtquick-controls2-suru,
 qml-module-qtwebengine,
 qml-module-quickflux,
 qmfmessageserver,
Description: Convergent email client
 Dekko is a much liked app for Ubuntu Touch's shell Lomiri. Ubuntu Touch
 is a mobile OS developed by the UBports Foundation. Lomiri is its
 operating environment optimized for touch based human-machine
 interaction, but also supports convergence (i.e. switching between
 tablet/phone and desktop mode).
 .
 Dekko is an convergent email client which supports the IMAP and SMTP
 protocols and lets you add multiple accounts.

Package: lomiri-dekko-app
Architecture: all
Depends:
 ${misc:Depends},
 dekko (>= ${source:Version}),
 lomiri-app-launch-tools,
Description: Wrapper package around dekko, but with Lomiri namespacing
 Dekko is a much liked app for Ubuntu Touch's shell Lomiri. Ubuntu Touch
 is a mobile OS developed by the UBports Foundation. Lomiri is its
 operating environment optimized for touch based human-machine
 interaction, but also supports convergence (i.e. switching between
 tablet/phone and desktop mode).
 .
 This package provides a wrapper script for launching dekko as
 'lomiri-dekko-app' from the command-line.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_HARDENING=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DCLICK_MODE=OFF \
	    -DDEKKO_UNCONFINED=ON \
	    -DDEKKO_SYSTEM_QUICKFLUX=ON \
	    -DDEKKO_SYSTEM_QMF=ON

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/tmp/usr/lib/*/qt5/qml/Dekko/Python/pynliner/__pycache__/
	rm debian/tmp/usr/lib/*/qt5/qml/Dekko/Notify/LICENSE

override_dh_installsystemduser:
	dh_installsystemduser --name dekko-qmfmessageserver

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --repack --destdir=..
